<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑运费模板' : '添加运费模板'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="" name="templateId">
        <a-input
          allow-clear
          placeholder="请输入"
          v-model:value="form.templateId"
        />
      </a-form-item>
      <a-form-item label="0按件" name="type">
        <a-input
          allow-clear
          placeholder="请输入0按件"
          v-model:value="form.type"
        />
      </a-form-item>
      <a-form-item label="" name="provinceId">
        <a-input
          allow-clear
          placeholder="请输入"
          v-model:value="form.provinceId"
        />
      </a-form-item>
      <a-form-item label="" name="cityId">
        <a-input allow-clear placeholder="请输入" v-model:value="form.cityId" />
      </a-form-item>
      <a-form-item label="首件数量/重量" name="firstNum">
        <a-input
          allow-clear
          placeholder="请输入首件数量/重量"
          v-model:value="form.firstNum"
        />
      </a-form-item>
      <a-form-item label="收件价格" name="firstAmount">
        <a-input
          allow-clear
          placeholder="请输入收件价格"
          v-model:value="form.firstAmount"
        />
      </a-form-item>
      <a-form-item label="续件价格" name="extraAmount">
        <a-input
          allow-clear
          placeholder="请输入续件价格"
          v-model:value="form.extraAmount"
        />
      </a-form-item>
      <a-form-item label="续件数量/重量" name="extraNum">
        <a-input
          allow-clear
          placeholder="请输入续件数量/重量"
          v-model:value="form.extraNum"
        />
      </a-form-item>
      <a-form-item
        label="状态, 0已发布, 1待审核 2已驳回 3违规内容"
        name="status"
      >
        <a-radio-group v-model:value="form.status">
          <a-radio :value="0">显示</a-radio>
          <a-radio :value="1">隐藏</a-radio>
        </a-radio-group>
      </a-form-item>
      <a-form-item label="是否删除, 0否, 1是" name="deleted">
        <a-input
          allow-clear
          placeholder="请输入是否删除, 0否, 1是"
          v-model:value="form.deleted"
        />
      </a-form-item>
      <a-form-item label="修改时间" name="updateTime">
        <a-input
          allow-clear
          placeholder="请输入修改时间"
          v-model:value="form.updateTime"
        />
      </a-form-item>
      <a-form-item label="" name="sortNumber">
        <a-input-number
          :min="0"
          :max="9999"
          class="ele-fluid"
          placeholder="请输入排序号"
          v-model:value="form.sortNumber"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import {
    addShopExpressTemplateDetail,
    updateShopExpressTemplateDetail
  } from '@/api/shop/shopExpressTemplateDetail';
  import { ShopExpressTemplateDetail } from '@/api/shop/shopExpressTemplateDetail/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ShopExpressTemplateDetail | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ShopExpressTemplateDetail>({
    id: undefined,
    templateId: undefined,
    type: undefined,
    provinceId: undefined,
    cityId: undefined,
    firstNum: undefined,
    firstAmount: undefined,
    extraAmount: undefined,
    extraNum: undefined,
    deleted: undefined,
    tenantId: undefined,
    createTime: undefined,
    updateTime: undefined,
    status: 0,
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    shopExpressTemplateDetailName: [
      {
        required: true,
        type: 'string',
        message: '请填写运费模板名称',
        trigger: 'blur'
      }
    ]
  });

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value
          ? updateShopExpressTemplateDetail
          : addShopExpressTemplateDetail;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
